' Visueller Sudoku-Knacker
' (c) 2007 by Andreas Meile, CH-8242 Hofen SH

' Statt mit Rekursion wird mit Iterationen gearbeitet
' Kann folglich nur Rtsel lsen, bei denen man mit Ausschluss und
' Zeilen/Spaltenoperationen ans Ziel kommt

DIM f%(8, 8), s%(9), zeiSpa%(8, 8), str%(8, 8)

INPUT "Datei mit Sudokan-Rtsel"; d$

OPEN d$ FOR INPUT AS 1
FOR y% = 0 TO 8
  LINE INPUT #1, h$
  FOR x% = 0 TO 8
    f%(x%, y%) = ASC(MID$(h$, x% + 1, 1)) - 48
  NEXT x%
NEXT y%
CLOSE 1

SCREEN 0
' WIDTH 40, 25
CLS

t$ = ""
FOR i% = 1 TO 5
  READ h$
  t$ = t$ + h$
NEXT i%
DATA "˻"
DATA "׶"
DATA " "
DATA "ι"
DATA "ʼ"

' Feld zeichnen
COLOR 13
PRINT " Aktueller Lsungsstand"
COLOR 7
FOR y% = 0 TO 18
  IF y% = 0 THEN
    ty% = 0
  ELSEIF y% = 18 THEN
    ty% = 4
  ELSEIF y% MOD 6 = 0 THEN
    ty% = 3
  ELSEIF y% MOD 2 = 0 THEN
    ty% = 1
  ELSE
    ty% = 2
  END IF
  FOR x% = 0 TO 18
    IF x% = 0 THEN
      tx% = 0
    ELSEIF x% = 18 THEN
      tx% = 4
    ELSEIF x% MOD 6 = 0 THEN
      tx% = 3
    ELSEIF x% MOD 2 = 0 THEN
      tx% = 1
    ELSE
      tx% = 2
    END IF
    LOCATE 3 + y%, 1 + x%
    PRINT MID$(t$, 1 + 5 * ty% + tx%, 1);
  NEXT x%
NEXT y%

LOCATE 6, 22
COLOR 7
PRINT "Legende"
LOCATE 7, 22
COLOR 9
PRINT " Zeile/Spalte"
LOCATE 8, 22
COLOR 9, 4
PRINT "";
COLOR 5, 0
PRINT " auf beide Arten"
LOCATE 9, 22
COLOR 4
PRINT " Ausschluss"

' Vorgegebene Ziffern darstellen
COLOR 14
af% = 0
FOR y% = 0 TO 8
  FOR x% = 0 TO 8
    IF f%(x%, y%) > 0 THEN
      LOCATE 4 + 2 * y%, 2 + 2 * x%
      PRINT CHR$(48 + f%(x%, y%));
    END IF
  NEXT x%
NEXT y%
pass% = 0
GOSUB ZeigeLuecken

' Lsung: Iterativ
DO
  GOSUB ZeigePass
  ' Zeilen/Spaltenoperationen
  FOR y% = 0 TO 8
    FOR x% = 0 TO 8
      zeiSpa%(x%, y%) = 0
    NEXT x%
  NEXT y%
  FOR z% = 1 TO 9  ' Fokus auf alle Zahlen
    ' Zu Beginn besetzte Felder bestimmen
    FOR y% = 0 TO 8
      FOR x% = 0 TO 8
        str%(x%, y%) = f%(x%, y%) > 0
      NEXT x%
    NEXT y%
    ' Sperrungen streichen
    FOR y% = 0 TO 8
      FOR x% = 0 TO 8
        IF f%(x%, y%) = z% THEN
          FOR i% = 0 TO 8
            str%(i%, y%) = -1 ' Zeile streichen
            str%(x%, i%) = -1 ' Spalte streichen
            str%(3 * (x% \ 3) + i% MOD 3, 3 * (y% \ 3) + i% \ 3) = -1 ' Teilquadrat
          NEXT i%
        END IF
      NEXT x%
    NEXT y%
    ' Eindeutige Zahlen finden
    FOR i% = 0 TO 8
      stZ% = 0
      stS% = 0
      stQ% = 0
      FOR j% = 0 TO 8
        ' Zeile
        IF str%(j%, i%) THEN
          stZ% = stZ% + 1
        ELSE
          pZ% = j%
        END IF
        ' Spalte
        IF str%(i%, j%) THEN
          stS% = stS% + 1
        ELSE
          pS% = j%
        END IF
        ' Quadrat
        IF str%(3 * (i% MOD 3) + j% MOD 3, 3 * (i% \ 3) + j% \ 3) THEN
          stQ% = stQ% + 1
        ELSE
          pQ% = j%
        END IF
      NEXT j%
      IF stZ% = 8 THEN
        zeiSpa%(pZ%, i%) = z%
      END IF
      IF stS% = 8 THEN
        zeiSpa%(i%, pS%) = z%
      END IF
      IF stQ% = 8 THEN
        zeiSpa%(3 * (i% MOD 3) + pQ% MOD 3, 3 * (i% \ 3) + pQ% \ 3) = z%
      END IF
    NEXT i%
    ' GOSUB Dump
  NEXT z%
  ' Ausschluss
  FOR y% = 0 TO 8
    FOR x% = 0 TO 8
      IF f%(x%, y%) = 0 THEN
        FOR i% = 0 TO 9
          s%(i%) = 0
        NEXT i%
        FOR i% = 0 TO 8
          ' Zeile
          s%(f%(i%, y%)) = -1
          ' Spalte
          s%(f%(x%, i%)) = -1
          ' Quadrat
          s%(f%(3 * (x% \ 3) + i% MOD 3, 3 * (y% \ 3) + i% \ 3)) = -1
        NEXT i%
        j% = 0
        FOR i% = 1 TO 9
          IF s%(i%) THEN
            j% = j% + 1
          ELSE
            k% = i%
          END IF
        NEXT i%
        IF j% = 8 THEN
          str%(x%, y%) = k%
        ELSE
          str%(x%, y%) = 0
        END IF
      ELSE
        str%(x%, y%) = 0
      END IF
    NEXT x%
  NEXT y%
  ' Auswerten und darstellen
  anzAuss% = 0
  anzZeiSpa% = 0
  anzTot% = 0
  FOR y% = 0 TO 8
    FOR x% = 0 TO 8
      IF zeiSpa%(x%, y%) > 0 OR str%(x%, y%) > 0 THEN
        LOCATE 4 + 2 * y%, 2 + 2 * x%
        IF zeiSpa%(x%, y%) = 0 THEN
          ' reiner Ausschluss
          COLOR 4, 0
          PRINT "";
        ELSEIF str%(x%, y%) = 0 THEN
          ' reine Zeilen-Spaltenoperation
          COLOR 9, 0
          PRINT "";
        ELSE
          ' auf beide Arten bestimmbar
          COLOR 9, 4
          PRINT "";
        END IF
        IF zeiSpa%(x%, y%) > 0 THEN
          anzZeiSpa% = anzZeiSpa% + 1
        END IF
        IF str%(x%, y%) > 0 THEN
          anzAuss% = anzAuss% + 1
        END IF
        anzTot% = anzTot% + 1
      END IF
    NEXT x%
  NEXT y%
  LOCATE 23, 2
  COLOR 4, 0
  PRINT USING "Ausschluss:##"; anzAuss%;
  COLOR 9
  PRINT USING " Zeile/Spalte:##"; anzZeiSpa%;
  COLOR 13
  PRINT USING " Total:##"; anzTot%;
  d$ = INPUT$(1)
  ' Einsetzen
  COLOR 10
  aL% = 0
  FOR y% = 0 TO 8
    FOR x% = 0 TO 8
      IF zeiSpa%(x%, y%) > 0 THEN
        z% = zeiSpa%(x%, y%)
      ELSE
        z% = str%(x%, y%)
      END IF
      IF z% > 0 THEN
        f%(x%, y%) = z%
        LOCATE 4 + 2 * y%, 2 + 2 * x%
        PRINT CHR$(48 + z%);
      END IF
    NEXT x%
  NEXT y%
  GOSUB ZeigeLuecken
  d$ = INPUT$(1)
LOOP WHILE anzTot% > 0 AND aL% > 0

LOCATE 20, 22
IF aL% = 0 THEN
  COLOR 10
  PRINT "Erfolgreich gelst"
ELSE
  COLOR 12
  PRINT "Kombinationen ntig->Abbruch"
END IF

dummy$ = INPUT$(1)
COLOR 7, 0
LOCATE 22, 1
' SCREEN 0
' WIDTH 80, 25
' CLS

END

ZeigeLuecken:
aL% = 0
FOR y% = 0 TO 8
  FOR x% = 0 TO 8
    IF f%(x%, y%) = 0 THEN
      aL% = aL% + 1
    END IF
  NEXT x%
NEXT y%
COLOR 11
LOCATE 22, 22
PRINT USING "Anzahl Lcken:##"; aL%;
RETURN

ZeigePass:
pass% = pass% + 1
COLOR 3
LOCATE 21, 22
PRINT USING "Pass Nr. ##"; pass%;
RETURN

